︠8d326e9a-e735-46b7-8f18-0a1bb475fc7bs︠
reset
︡b6d530d3-bd87-4c8d-adae-595676b3af37︡{"stdout":"<function reset at 0x7f127d4c20c8>"}︡{"stdout":"\n"}︡{"done":true}
︠c1393761-2158-4f86-83c4-f6c1abc7ccfcs︠
#Exercise 1:Synthetic (long) division
# Make a function long_div(L, c)  that takes a list L=[a_n,_(n-1),...,a_0] of length n+1 of coefficients of a polynomial p  and a number c and returns the list B  of length n+1. The first  n  elements of B are the coefficients of the quotient (p(x))/(x-c). The last element on the list S is the remainder. Test your function on example of your choice.

#//Input:
#//Output:
def long_div(L, c):
    S=[L[0]]
    for j in range(1,len(L)):
        temp= L[j] + c*S[j-1] #See Lecture 4 for the formula that defines coefficient of the quotient
        S.append(temp)
    return S
L=[3,2,-5,1];# p=3x^3+2x^2-5x+1
long_div(L,2)
︡208c02ad-4eb0-46ec-86a6-daadfb2bfb42︡{"stdout":"[3, 8, 11, 23]\n"}︡{"done":true}
︠97de65a4-f119-48d6-a425-92aad4a1850es︠
#Answer: quotient: 3x^2+8x+11; remainder: 23. Check:
simplify(expand((3*x^2+8*x+11)*(x-2)+23))# This is the given polynomial.
︡febbf954-a71a-4fdb-a0ec-1ff59b34abf2︡{"stdout":"3*x^3 + 2*x^2 - 5*x + 1"}︡{"stdout":"\n"}︡{"done":true}
︠d7f9837d-9118-4ba8-9e69-0dbb06a41295s︠
# Remark: How to make a list of all divisors of an integer
S=divisors(45);S;P=[-c for c in S];P;S+P

︡aaa29891-536a-411d-bcde-1292aa3892e5︡{"stdout":"[1, 3, 5, 9, 15, 45]\n[-1, -3, -5, -9, -15, -45]\n[1, 3, 5, 9, 15, 45, -1, -3, -5, -9, -15, -45]\n"}︡{"done":true}
︠7674b833-4fe7-4789-8aec-63107e1be2ces︠
#################
#Exercise 2. Finding integer roots of monic polynomials
#(a) Make a function find_int_roots(A) that takes a list L of coefficients of a monic polynomial p with integer constant term and returns the list S  of integer roots of the polynomial. If the polynomial does not have integer roots, the function returns the empty list. Test your function on the polynomial p(x)=x^4+2 x^3-x^2-8 x-12. Find all integer roots.
#Your code will be more readable if you define first a function that evaluates a polynomial
#//Input: The input is a polynomial
#//Output: The output are the roots of the polynomial if it can be simplified. All roots inputted into the polynomial should return 0.
def poly_val(A,c):#
    val=A[0]
    for j in range(1,len(A)):
        val=val*c+A[j]
    return val
#Example
poly_val([3,5,-2],1/3)# Show your own example
︡f34aa348-7b34-42b9-bbb6-5b0adbfd6202︡{"stdout":"0\n"}︡{"done":true}
︠d2cbf72f-9932-40df-9eb4-114c07512cd5s︠
#Answer: 1/3 is the root of the polynomial p=3x^2+5x-2

#//Input:Input is a polynomial
#//Output: The output are the roots of the polynomial. If the roots are put into the polynomial, then the output, both times, should be 0.
def find_int_roots(L): #L=[1,a_(n-1),...,a_0],a_0 must be an integer
    divs_pos=divisors(L[-1])# L[-1] is the last element on the list
    divs_neg=[-c for c in divs_pos]
    divs=divs_pos+divs_neg
    int_roots=[]
    for c in divs:
        if poly_val(L,c)==0:
            int_roots.append(c)
    return int_roots
#Example:p=x^4+2*x^3-x^2-8*x-12
L=[1,2,-1,-8,-12];find_int_roots(L)# Show your own example
#Answer to part (a): integer zeros of the polynomial p are
︡ceb64d44-4f73-46a2-bd0d-db53fe87e561︡{"stdout":"[2, -2]\n"}︡{"done":true}
︠012c84a4-0ecd-400f-ad7a-d40ab037521fs︠
#(b) Use the function long_division to find the polynomial p(x)/((x-2)(x+2))
# My example: p=x^4+2*x^3-x^2-8*x-12 (the polynomial used in (a) part of this exercise)
# Show your own example
L=[1,2,-1,-8,-12]
L1=long_div(L, 2);L1 #List of coefficients of p/(x-2)
︡8df56cff-c579-4d39-9605-09eebac9cf92︡{"stdout":"[1, 4, 7, 6, 0]\n"}︡{"done":true}
︠4e4b695a-d5f4-489c-b0ae-517858274c4ds︠
L2=long_div(L1,-2);L2
#Answer to part (b): p(x)/(x^2-4)=x^2+2x+3
︡2758c99e-4887-4d93-a928-187768fb7fb9︡{"stdout":"[1, 2, 3, 0, 0]\n"}︡{"done":true}
︠b2d24505-4fa7-4788-b58b-eaf925ec09fes︠
#########################
#Exercise 3. Make a function remove_xsquared(L) that takes a polynomial with real coefficients and returns the number c such that substitution x = t-c eliminates the quadratic term in p. Check your code on a cubic polynomial of your choice.

#I experimented with SageMath commands for this task interactively:
reset
var('t c')
p=x^3+3.5*x^2-2.1*x+4.0 # my example
q=p.subs(x=t-c);q
︡2d56b1e2-cf4c-4f7c-b66e-2d58e04b435b︡{"stdout":"<function reset at 0x7f127d4c20c8>\n"}︡{"stdout":"(t, c)\n"}︡{"stdout":"-(c - t)^3 + 3.50000000000000*(c - t)^2 + 2.10000000000000*c - 2.10000000000000*t + 4.00000000000000\n"}︡{"done":true}
︠ab747221-65d9-4283-b12f-728cedd02acfs︠
r=q.expand();r
︡15cdac69-ac39-4e70-8138-024f566d5029︡{"stdout":"-c^3 + 3*c^2*t - 3*c*t^2 + t^3 + 3.50000000000000*c^2 - 7.00000000000000*c*t + 3.50000000000000*t^2 + 2.10000000000000*c - 2.10000000000000*t + 4.00000000000000\n"}︡{"done":true}
︠937f1a28-0471-47ca-93ab-e4f933e3fc69s︠
coef2=r.coefficient(t,n=2);coef2 #It is simple to solve the equation coef2=0 manually. In the next cell I asked SageMath to do this. It is more tricky but will be useful later in the course.
︡2de74146-8d43-46b3-8468-c23136cb641c︡{"stdout":"-3*c + 3.50000000000000\n"}︡{"done":true}
︠264021e6-4778-448a-88eb-707ad2f9d140s︠
B=coef2.solve(c,solution_dict=True);B #It is convenient to use disctionary for accessing solution to equations (remember this!). The list B has only one element, the dictionary with key c and value 7/6
︡c6702186-7e98-434a-b3de-3cd0848aacb3︡{"stdout":"[{c: 7/6}]\n"}︡{"done":true}
︠16354592-d324-45e6-9641-8a5e7fbff887s︠
cval=B[0][c];cval
︡40b7ade2-8fbd-4f78-b895-13bb1b15175f︡{"stdout":"7/6\n"}︡{"done":true}
︠1c786f21-4a95-4b66-8db4-629e3f37d5b7s︠
r.subs(c=cval)# It works, no term with t^2
︡a7ff1b3a-4c9a-437a-b1fc-60c93dfb8cc0︡{"stdout":"t^3 - 6.18333333333334*t + 9.62592592592592\n"}︡{"done":true}
︠ebf4fb24-1e3c-4b1d-b0eb-fa747df55ec3s︠
# Assemble my interactive solution into a function. L must be a list of coefficients of a cubic polynoimial with quadratic term present. Therefore len(L)=4 and L[1] is a nonzero number.
# //Input:
# //Output:
var('t c')
def remove_xsquared(L):
    p=L[0]*x^3+L[1]*x^2+L[2]*x+L[3]
    q=p.subs(x=t-c)
    r=q.expand()
    coef2=r.coefficient(t,n=2)
    B=coef2.solve(c,solution_dict=True)
    cval=B[0][c]
    return r.subs(c=cval)

#Example (Use your own example)
remove_xsquared([8,-2,5,7])# It works, no term with t^2
︡9832a343-29c4-4269-8756-84b054fd780b︡{"stdout":"(t, c)\n"}︡{"stdout":"8*t^3 + 29/6*t + 200/27\n"}︡{"done":true}
︠9cd5666e-e20c-4d14-9b0b-9f35f41c233ds︠
##########################
#Exercise 5. Make a function roots_of_unity(n) that takes a natural number n and returns a list of all n^th  roots of unity. Use your function for n = 7  and plot corresponding regular heptagon inscribed into the unit circle. Note that a heptagon is not constructible polygon, that is, it cannot be constructed with compass and straightedge.
#//
#//
def roots_of_unity(n):
    L=[N(cos(2*pi*k/n) + i*sin((2*pi*k)/n)) for k in range(n)]#Encode the formula for roots of unity from Lecture 4
    return L

#roots_of_unity(7)

L = roots_of_unity(7);L
︡bb46c68b-4ed4-41c3-9cdd-40467e22c5d8︡{"stdout":"[1.00000000000000, 0.623489801858734 + 0.781831482468030*I, -0.222520933956314 + 0.974927912181824*I, -0.900968867902419 + 0.433883739117558*I, -0.900968867902419 - 0.433883739117558*I, -0.222520933956314 - 0.974927912181824*I, 0.623489801858734 - 0.781831482468030*I]\n"}︡{"done":true}
︠f8b2e3af-0623-435e-a48a-f1ddc41c030es︠
S = [(L[j].real(),L[j].imag()) for j in range(7)]; S
︡24030ded-f4b0-4c8c-94f1-ae0ef9017091︡{"stdout":"[(1.00000000000000, 0), (0.623489801858734, 0.781831482468030), (-0.222520933956314, 0.974927912181824), (-0.900968867902419, 0.433883739117558), (-0.900968867902419, -0.433883739117558), (-0.222520933956314, -0.974927912181824), (0.623489801858734, -0.781831482468030)]\n"}︡{"done":true}
︠4ab7d14f-b14f-4dea-9a30-abb9ccc3f6d2s︠
point(S,aspect_ratio=1,size=30)
︡f0cc2c91-7fb7-4f68-8804-f8ddc4e4d2a2︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/1309/tmp_vX1Pai.svg","show":true,"text":null,"uuid":"42e2217c-5ef4-4b75-9edd-0f582660fb58"},"once":false}︡{"done":true}
︠7f71085a-2e55-4f19-921f-27cfcbe4bca5︠









